'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _ReactDebugTool = require('react-dom/lib/ReactDebugTool');

var _ReactDebugTool2 = _interopRequireDefault(_ReactDebugTool);

var _ReactComponentTreeHook = require('react/lib/ReactComponentTreeHook');

var _ReactComponentTreeHook2 = _interopRequireDefault(_ReactComponentTreeHook);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SuiPerfHook = function () {
  function SuiPerfHook(perf) {
    (0, _classCallCheck3.default)(this, SuiPerfHook);

    this.perf = perf;
  }

  (0, _createClass3.default)(SuiPerfHook, [{
    key: 'isNativeComponent',
    value: function isNativeComponent(debugID) {
      var label = _ReactComponentTreeHook2.default.getDisplayName(debugID) || 'unknown';
      return label[0].toLowerCase() === label[0];
    }
  }, {
    key: 'getMarkName',
    value: function getMarkName(debugID) {
      return '<' + (_ReactComponentTreeHook2.default.getDisplayName(debugID) || 'Unknown') + '>';
    }
  }, {
    key: 'onBeforeMountComponent',
    value: function onBeforeMountComponent(debugID, element, parentDebugID) {
      !this.isNativeComponent(debugID) && this.perf.mark(this.getMarkName(debugID));
    }
  }, {
    key: 'onMountComponent',
    value: function onMountComponent(debugID, element, parentDebugID) {
      !this.isNativeComponent(debugID) && this.perf.stop(this.getMarkName(debugID));
    }
  }]);
  return SuiPerfHook;
}();

var measureReact = function measureReact(perf) {
  var perfHook = new SuiPerfHook(perf);
  _ReactDebugTool2.default.addHook(perfHook);
  return _ReactDebugTool2.default.removeHook.bind(_ReactDebugTool2.default, perfHook);
};

exports.default = measureReact;